using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Imaging;
using System.Text;
using System.Windows.Forms;
using System.IO;
using Tao.OpenGl;
using Tao.Platform.Windows;


namespace Turtles
{
    public partial class TurtlesForm : Form
    {
        private double winX = 4.0;//Graphics Window
        private double winY = 4.0;

        private double curX;        //new point
        private double curY;
        private double prevX;       //old point
        private double prevY;

        private double angle=30;
        private double startLen=0.04;
        private double incLen=0.01;
        private int curl = 250;
        private Bitmap bitmap;

        public TurtlesForm()
        {
            InitializeComponent();
            glControl.InitializeContexts();
            initOpenGl();
            bitmap = new Bitmap(700, 700);
        }
        public void initOpenGl()
        {
            this.SetBounds(0, 0, 700, 700);

            Gl.glViewport(0, 0, 700, 700);//rect.Width, rect.Height);
            Gl.glClearColor(0, 0, 0, 1);
            Gl.glClear(Gl.GL_COLOR_BUFFER_BIT);

            Gl.glMatrixMode(Gl.GL_PROJECTION);
            Gl.glLoadIdentity();
            Glu.gluOrtho2D(-winX / 2,  winX / 2, -winY / 2, winY / 2);

            this.Refresh();
        }
        private void glControl_Paint(object sender, PaintEventArgs e)
        {
            Gl.glClear(Gl.GL_COLOR_BUFFER_BIT);
            Gl.glColor3d(0.976, 0.114, 0.254);
            drawPatternNGons(startLen,angle,incLen);
        }

        private void glControl_Resize(object sender, EventArgs e)
        {
            this.SetBounds(0, 0, 700, 700);
            Gl.glViewport(0, 0, 700,700);
            Gl.glMatrixMode(Gl.GL_PROJECTION);
            Gl.glLoadIdentity(); 
         
            Glu.gluOrtho2D(-winX / 2, winX / 2, -winY / 2, winY / 2);
            this.Refresh();
        }
        private void turn(double theta, double length)
        {
            theta = theta * Math.PI / 180.0;    //change degree to radian
            curX = prevX+length * Math.Cos(theta);
            curY = prevY+length * Math.Sin(theta);
        }
        private void forward()
        {
            Gl.glBegin(Gl.GL_LINES);
                Gl.glVertex2d(prevX, prevY);
                Gl.glVertex2d(curX, curY);
            Gl.glEnd();
            prevX = curX;
            prevY = curY;
        }
        private void drawPatternNGons(double length, double theta, double dl)
        {
            double len=length;
            for (int m = 0; m < curl; m++)
            {
                turn(m*theta, len);
                forward();
                len = len + dl;
            }
            prevX = 0.0;
            prevY = 0.0;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            angle = 60.0;
            incLen = 0.005;
           
            glControl.Invalidate();
           
        }

        private void button2_Click(object sender, EventArgs e)
        {
            angle = 89.5;
            incLen = 0.01;
            glControl.Invalidate();          
        }

        private void button3_Click(object sender, EventArgs e)
        {
            angle = -144.0;
            incLen = 0.01;
            glControl.Invalidate();                
        }

        private void button4_Click(object sender, EventArgs e)
        {
            angle = 170.0;//163.91
            incLen = 0.01;
            glControl.Invalidate();            
        }

        private void button5_Click(object sender, EventArgs e)
        {
            angle = 181.3;
            //angle = 184.7;
            //angle = 185.9;
            incLen = 0.01;
            glControl.Invalidate();             
        }

        private void button6_Click(object sender, EventArgs e)
        {
            angle = 153.1;
            incLen = 0.01;
            glControl.Invalidate();            
        }

        private void button7_Click(object sender, EventArgs e)
        {
            angle = 237.7;
            incLen = 0.01;
            glControl.Invalidate();                  
        }

        private void button8_Click(object sender, EventArgs e)
        {
            angle = 199.39;
            incLen = 0.01;
            glControl.Invalidate();             
        }

        private void button9_Click(object sender, EventArgs e)
        {
            angle = -135.0;
            incLen = 0.01;
            glControl.Invalidate();                    
        }

        private void button10_Click(object sender, EventArgs e)
        {         
            angle = -51.7;
            incLen = 0.005;
            glControl.Invalidate();            
        }

        //public void setBitmap()
        //{
        //    for(int i=0;i<700;i++)
        //        for (int j = 0; j < 700; j++)
        //        {

        //        }

        //}

        //public void save(Bitmap bitmap, String file, ImageFormat imgFormat)
        //{
        //    file = file.ToLower();
        //    string str = "";
        //    if (imgFormat.Guid == ImageFormat.Png.Guid)
        //        str = ".Png";
        //    if (imgFormat.Guid == ImageFormat.Jpeg.Guid)
        //        str = ".Jpg";
        //    if (imgFormat.Guid == ImageFormat.Bmp.Guid)
        //        str = ".Bmp";
        //    file = file.Replace(".jpg", str);
        //    file = file.Replace(".bmp", str);
        //    file = file.Replace(".png", str);

        //    try
        //    {
        //        bitmap.Save(file, imgFormat);
        //    }
        //    catch (Exception exc)
        //    {
        //        MessageBox.Show("Error in File Handling");
        //    }
        //}
    }
}